#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <fcntl.h>
#include <netdb.h>
#include <string.h>

#define PORT 1053

static char buf[4096];

main(int ac,char** av)
{
 int sd, pid, f, l, i;
 struct sockaddr_in s_a;
 struct hostent *hp; //  
 char** file; //     

 if( ac<3 ) fprintf(stderr,"client: Empty in argv[]\n"), exit(1);

 hp = gethostbyname(av[1]);
 if( !hp ) perror("client"), exit(2);
 
 file = av+2;
 
 sd = socket(AF_INET,SOCK_STREAM,0); /*   */
 if( sd< 0 ){ perror("server"); exit(1); }

 bzero(&s_a,sizeof s_a);
 bcopy(hp->h_addr,&s_a.sin_addr,hp->h_length);
 s_a.sin_family = AF_INET;
 s_a.sin_port = htons((u_short) PORT);

 if( connect(sd,(struct sockaddr*)&s_a,sizeof s_a)<0 ) perror("client"), exit(2);
 
 fprintf(stderr,"Connect to server.\n");
 
while( *file )
{
 fprintf(stderr,"Write file %s in socket.\n",*file);
 f = open(*file,O_RDONLY);
 if(!f){ perror("client"); file++; continue;}
 
 l = lseek(f,0,2); //   
     lseek(f,0,0); // .     
     
     send(sd,&l,sizeof l,0); //   
     send(sd,*file,strlen(*file),0); //   
     recv(sd,buf,2,0); //    
     if( memcmp(buf,"OK",2) ) fprintf(stderr,"ERROR: No supported protocol!\n"), exit(4);
     
     for(i = sizeof buf; i<l; i+=sizeof buf)
     {
      read(f,buf,sizeof buf); //        
      send(sd,buf,sizeof buf,0);
     }
     l=l-(i-sizeof buf);
      read(f,buf,l);
      send(sd,buf,l,0);
      close(f);      
      file++;
      buf[0]='\0';
      recv(sd,buf,3,0);
      if( memcmp(buf,"END",3)!=0 ) //   
      {
       fprintf(stderr,"Server not write END!\n");
       break;
      }
}

fprintf(stderr,"Disconnect from Server...\n"); 

 close(sd);
}
 